{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "![Callysto.ca Banner](https://github.com/callysto/curriculum-notebooks/blob/master/callysto-notebook-banner-top.jpg?raw=true)\n",
    "\n",
    "<a href=\"https://hub.callysto.ca/jupyter/hub/user-redirect/git-pull?repo=https%3A%2F%2Fgithub.com%2Fcallysto%2Fcurriculum-notebooks&branch=master&subPath=Mathematics/InductiveAndDeductiveReasoning/inductive-and-deductive-reasoning.ipynb&depth=1\" target=\"_parent\"><img src=\"https://raw.githubusercontent.com/callysto/curriculum-notebooks/master/open-in-callysto-button.svg?sanitize=true\" width=\"123\" height=\"24\" alt=\"Open in Callysto\"/></a>"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 1,
   "metadata": {
    "tags": [
     "hide-input"
    ]
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "\n",
       "<script>\n",
       "  function code_toggle() {\n",
       "    if (code_shown){\n",
       "      $('div.input').hide('500');\n",
       "      $('#toggleButton').val('Show Code')\n",
       "    } else {\n",
       "      $('div.input').show('500');\n",
       "      $('#toggleButton').val('Hide Code')\n",
       "    }\n",
       "    code_shown = !code_shown\n",
       "  }\n",
       "\n",
       "  $( document ).ready(function(){\n",
       "    code_shown=false;\n",
       "    $('div.input').hide()\n",
       "  });\n",
       "</script>\n",
       "<p> Code is hidden for ease of viewing. Click the Show/Hide button to see. </>\n",
       "<form action=\"javascript:code_toggle()\"><input type=\"submit\" id=\"toggleButton\" value=\"Show Code\"></form>\n"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "%%html\n",
    "\n",
    "<script>\n",
    "  function code_toggle() {\n",
    "    if (code_shown){\n",
    "      $('div.input').hide('500');\n",
    "      $('#toggleButton').val('Show Code')\n",
    "    } else {\n",
    "      $('div.input').show('500');\n",
    "      $('#toggleButton').val('Hide Code')\n",
    "    }\n",
    "    code_shown = !code_shown\n",
    "  }\n",
    "\n",
    "  $( document ).ready(function(){\n",
    "    code_shown=false;\n",
    "    $('div.input').hide()\n",
    "  });\n",
    "</script>\n",
    "<p> Code is hidden for ease of viewing. Click the Show/Hide button to see. </>\n",
    "<form action=\"javascript:code_toggle()\"><input type=\"submit\" id=\"toggleButton\" value=\"Show Code\"></form>"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "metadata": {
    "tags": [
     "hide-input"
    ]
   },
   "outputs": [],
   "source": [
    "from IPython.display import display, Math, Latex, HTML\n",
    "import ipywidgets as widgets"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "metadata": {
    "tags": [
     "hide-input"
    ]
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div id=\"ggbLoadMsg\"></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            window.ggbRequireStatus = 'loading';\n",
       "            requirejs.config({\n",
       "                paths: {\n",
       "                    ggb: \"https://cdn.geogebra.org/apps/deployggb\"\n",
       "                }\n",
       "            });\n",
       "\n",
       "            window.safeGGB = function safeGGB(counter, cb) {\n",
       "                if (window.ggbRequireStatus == 'failed') {\n",
       "                    console.log('panic-failed');\n",
       "                }\n",
       "\n",
       "                if (window.ggbRequireStatus == 'loading') {\n",
       "                    if (counter > 0) {\n",
       "                        console.log('in-loop' + counter);\n",
       "                        counter = counter-1;\n",
       "                        setTimeout(() => safeGGB(counter, cb), 2000);\n",
       "                    } else {\n",
       "                        console.log('panic-timeout');\n",
       "                    }\n",
       "                } else if (window.ggbRequireStatus == 'loaded') {\n",
       "                    cb();\n",
       "                }\n",
       "\n",
       "            }\n",
       "\n",
       "            requirejs(\n",
       "                [\"ggb\"],\n",
       "                () => {\n",
       "                    window.ggbRequireStatus = 'loaded';\n",
       "                    console.log('loaded');\n",
       "                    return;\n",
       "                },\n",
       "                (err) => {\n",
       "                    if (err.requireModules) {\n",
       "                        window.ggbRequireStatus = 'failed';\n",
       "                        console.error(\"There was an error while downloading one or more required Javascript Libraries.\");\n",
       "                        err.requireModules.forEach(failedItem => {\n",
       "                            console.error(\"Failed to load: \" + failedItem);\n",
       "                            $('#ggbLoadMsg').append('<p>Failed to load: ' + failedItem + '</p>');\n",
       "                        });\n",
       "                        $('#ggbLoadMsg').append('<p>Please check your internet connection.</p>');\n",
       "                        $('#ggbLoadMsg').css({'color':'red', 'font-size':'150%'});\n",
       "                    }\n",
       "                }\n",
       "            );\n",
       "\n",
       "            console.log(window.ggbRequireStatus);\n",
       "        "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "try:\n",
    "    from geogebra.ggb import *\n",
    "except ImportError:\n",
    "    !pip install --upgrade --force-reinstall --user git+git://github.com/callysto/nbplus.git#egg=geogebra\\&subdirectory=geogebra\n",
    "    from importlib import reload\n",
    "    import site\n",
    "    reload(site)\n",
    "    from geogebra.ggb import *    \n",
    "ggb = GGB().setDefaultOptions(enableShiftDragZoom=False)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# Inductive Reasoning and Deductive Reasoning\n",
    "\n",
    "There are two forms of reasoning that that are useful when investigating a piece of mathematics.\n",
    "\n",
    "* `Inductive reasoning` involves looking for **patterns** in evidence in order to come up with conjectures (i.e. things that are likely to be true). This sort of reasoning will **not** tell you whether or not something actually *is* true but it is still very useful for making connections and figuring out what to investigate next.\n",
    "\n",
    "* `Deductive reasoning` involves starting with what you **know** and logically figuring out if some conjecture **must** also be true (and why). While deductive reasoning is stronger than inductive reasoning, it can also be more difficult to use.\n",
    "\n",
    "In practice, one will often use `inductive reasoning` to make conjectures and `deductive reasoning` to verify them. In some cases producing a conjecture will require a mix of inductive and deductive reasoning.\n",
    "\n",
    "In this notebook we will go over some example problems to help illustrate how one would go about using `inductive` and `deductive` reasoning in problem solving while avoiding pitfalls. Being able to apply these skills will make you a more effective problem solver. Being able to distinguish between the two will help you maintain a clear understanding of what you're doing, why you're doing it, and avoid mistakes in the process."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## A Flawed Application of Inductive Reasoning\n",
    "\n",
    "Consider a circle. Suppose we were to add a certain number of dots to the edge of the circle and then draw chords connecting every pair of dots. The chords would partition the circle into a certain number of regions. *Can we find a relationship between the number of dots and the number of regions?* For instance, a circle with a two dots along the edge has one chord connecting them and is partitioned into two regions but a circle with three dots along the edge has three chords and is partitioned into four regions.\n",
    "\n",
    "Here is a simple applet to help visualize the problem. The slider at the bottom controls the number of dots along the edge (from $1$ to $6$). I've labeled each region with a number to make them easier to count."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 4,
   "metadata": {
    "tags": [
     "hide-input"
    ]
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "<iframe scrolling=\"no\" title=\"cc-20-chords\" src=\"https://www.geogebra.org/material/iframe/id/d4uwgs5k/width/700/height/700/border/888888/sfsb/true/smb/false/stb/false/stbh/false/ai/false/asb/false/sri/false/rc/false/ld/false/sdz/false/ctl/false\" width=\"700px\" height=\"700px\" style=\"border:0px;\"> </iframe>\n"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "%%html\n",
    "<iframe scrolling=\"no\" title=\"cc-20-chords\" src=\"https://www.geogebra.org/material/iframe/id/d4uwgs5k/width/700/height/700/border/888888/sfsb/true/smb/false/stb/false/stbh/false/ai/false/asb/false/sri/false/rc/false/ld/false/sdz/false/ctl/false\" width=\"700px\" height=\"700px\" style=\"border:0px;\"> </iframe>"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "If we look at the number of regions in the first five examples\n",
    "\n",
    "| dots | regions |\n",
    "| ---- | ------- |\n",
    "| 1    | 1       |\n",
    "| 2    | 2       |\n",
    "| 3    | 4       |\n",
    "| 4    | 8       |\n",
    "| 5    | 16      |\n",
    "\n",
    "and apply inductive reasoning then we may convince ourselves that the circle with $n$ dots will have $2^{n-1}$ regions.\n",
    "\n",
    "**Is that true?** *Note: If our inductive reasoning is correct then the sixth case will have $2^{6-1}=32$ regions.*"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Unfortunately, as it turns out the sixth circle will break down into $31$ regions, not $32$ regions. This is an example where inductive reasoning can lead you astray. Fortunately for us we managed to find a counterexample right away but there are conjectures where the first counterexample took decades to find and required numbers so large that it's virtually impossible for people to find them by hand. So we should always be very skeptical about the things inductive thinking may lead us to believe."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Some Flawed Applications of Deductive Reasoning\n",
    "\n",
    "Deductive reasoning can also fail us if we are not careful. It is possible to get caught up manipulating equations and not realize there's an underlying logical problem.\n",
    "\n",
    "Here are two flawed proofs. Try and find the problem in each one!\n",
    "\n",
    "### A Classic Flawed Proof\n",
    "\n",
    "There are a few variations of this proof (with the same flaw) floating around. Every so often a student rediscovers it and thinks they've broken math.\n",
    "\n",
    "Let $a=b$.\n",
    "\n",
    "Then it follows that $b^2=ab$.\n",
    "\n",
    "\n",
    "$$\n",
    "\\begin{align*}\n",
    "    a^2 - b^2 &= a^2 - b^2\\\\\n",
    "    a^2 - b^2 &= a^2 - ab \\tag{Since $b^2=ab$}\\\\\n",
    "    (a+b)(a-b) &= (a)(a-b) \\tag{Factoring}\\\\\n",
    "    a+b &= a \\tag{Divide by sides by $a-b$}\\\\\n",
    "    2a &= a \\tag{Since $a=b$}\\\\\n",
    "    2 &= 1 \\tag{Divide both sides by $a$}\n",
    "\\end{align*}\n",
    "$$\n",
    "\n",
    "\n",
    "Hint: The problem involves division.\n",
    "\n",
    "The problem is introduced when both sides are divided by $a-b$ because $a-b=0$ and division by zero is not allowed (for reasons like this).\n",
    "\n",
    "### A Flawed Proof Involving Radicals\n",
    "\n",
    "This one is somewhat less common but still interesting.\n",
    "\n",
    "\n",
    "$$\n",
    "\\begin{align*}\n",
    "    -1 \n",
    "    &= i^2 \\\\\n",
    "    &= (i)(i) \\\\\n",
    "    &= \\sqrt{-1}\\sqrt{-1} \\\\\n",
    "    &= \\sqrt{(-1)(-1)} \\\\\n",
    "    &= \\sqrt{1} \\\\\n",
    "    &= 1\n",
    "\\end{align*}\n",
    "$$\n",
    "\n",
    "\n",
    "So $-1=1$.\n",
    "\n",
    "Hint: The problem involves distributing roots.\n",
    "\n",
    "The problem occurs because $\\sqrt{ab}=\\sqrt{a}\\sqrt{b}$ only holds when $a$ and $b$ are both greater than or equal to $0$ (neither $a$ nor $b$ are allowed to be negative)."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Some Applications of Inductive Reasoning\n",
    "\n",
    "### Sum of the first n odd integers\n",
    "\n",
    "Suppose you need to compute the sum of the first $100$ odd integers. You could do this directly but that likely wouldn't be very fun or interesting. Let's instead try applying inductive reasoning to try to come up with a better way to do it.\n",
    "\n",
    "Before we can start looking for patterns we'll first need to generate some examples (so that we can use them as evidence later). Let's do that in Python:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 5,
   "metadata": {
    "scrolled": true,
    "tags": [
     "hide-input"
    ]
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "|  n | Odd | S(n)|\n",
      "------------------\n",
      "|  1 |   1 |   1 |\n",
      "|  2 |   3 |   4 |\n",
      "|  3 |   5 |   9 |\n",
      "|  4 |   7 |  16 |\n",
      "|  5 |   9 |  25 |\n",
      "|  6 |  11 |  36 |\n",
      "|  7 |  13 |  49 |\n",
      "|  8 |  15 |  64 |\n",
      "|  9 |  17 |  81 |\n",
      "| 10 |  19 | 100 |\n"
     ]
    }
   ],
   "source": [
    "# Create a list of odd integers from 1 to 20 (incrementing by 2 each time).\n",
    "oddIntegers = range(1,20,2)\n",
    "\n",
    "# Print a nice heading.\n",
    "print('|  n | Odd | S(n)|')\n",
    "print('------------------')\n",
    "\n",
    "# For each odd integer print the step, the integer, and the sum of all odd integers so far.\n",
    "step = 0\n",
    "oddSum = 0\n",
    "for odd in oddIntegers:\n",
    "    step = step + 1\n",
    "    oddSum = oddSum + odd\n",
    "    print('|{:3d} | {:3d} | {:3d} |'.format(step, odd, oddSum))"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "For brevity we'll use $S(n)$ to refer to the __sum of the first $n$ odd integers__.\n",
    "\n",
    "The code above gives us a list of the first $10$ odd integers as well as $S(n)$ for each one (eg. for $n=3$, the $3$rd odd is $5$ and $S(3) = 1 + 3 + 5 = 9$).\n",
    "\n",
    "Now look closely at the data and try to see if there is a pattern there. Maybe consider changing the 20 in `range(1,20,2)` to a larger value to obtain more examples.\n",
    "\n",
    "Hint: $1+3+5=3^2$."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "A good conjecture might be that\n",
    "\n",
    "$$S(n)=n^2.$$\n",
    "\n",
    "Here is a slider that tests our conjecture against a larger range of values:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 6,
   "metadata": {
    "tags": [
     "hide-input"
    ]
   },
   "outputs": [
    {
     "data": {
      "application/vnd.jupyter.widget-view+json": {
       "model_id": "2bee96ea1da64fed9c646bf6aa0606e9",
       "version_major": 2,
       "version_minor": 0
      },
      "text/plain": [
       "VBox(children=(IntSlider(value=1, description='n:', min=1), Output()))"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "num = widgets.IntSlider(description='n:', min=1)\n",
    "def oddCompare(num):\n",
    "    oddIntegers = range(1, num*2, 2)\n",
    "    oddSum = sum(list(oddIntegers))\n",
    "    print('S(n): {}'.format(oddSum))\n",
    "    print('n^2: {}'.format((num*num)))\n",
    "\n",
    "out = widgets.interactive_output(oddCompare, {'num': num})\n",
    "widgets.VBox([num, out])"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Now that we have a conjecture it is typically very helpful if we're able to take it further and come up with some guesses about __why__ the conjecture holds. In this case the trick is to realize that we can compute the sum of the first $n$ odd integers by taking the sum of the first $n-1$ odd integers and adding the $n$'th odd. In other words:\n",
    "\n",
    "$$S(n+1)=S(n) + (n+1)^{\\text{th}} \\text{ odd integer}.$$\n",
    "\n",
    "For instance, $S(5) = 1 + 3 + 5 + 7 + 9 = S(4) + 9$.\n",
    "\n",
    "Then combining this insight with the fact that we can represent square integers as squares yields this visualization:\n",
    "\n",
    "![Odds](./images/odds1.png \"odd sums\")\n",
    "<center>https://www.quora.com/What-is-the-sum-of-1+3+5+7+9+11+13+15+17+19+21+23+25+27+29+31+-+95+97+99</center>\n",
    "\n",
    "Unfortunately as convincing as this visual representation may be, it isn't strong enough to prove that $S(n)=n^2$ holds for all integers $n$. In order to prove that it holds for all $n$ we require a more advanced proof technique that we don't currently have access to. So we must grit our teeth and accept the fact that _as far as we know_ there could exist some integer out there for which this fails. Despite this some people will accept the visual argument as a proof because it provides the key intuition necessary to develop a proof."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Triangular numbers\n",
    "\n",
    "There is famous story about the mathematician Carl Friedrich Gauss who as a child in primary school was tasked with computing the sum of the first 100 integers as a way to keep him busy. As the story goes, Gauss quickly realized a pattern and wrote down the answer of 5050 within a few seconds.\n",
    "\n",
    "For brevity we'll use $T(n)$ to refer to the __sum of the first $n$ integers__.\n",
    "\n",
    "The trick to seeing the pattern in this problem isn't as straightforward as the last one. As before we'll need to generate some examples to analyze first."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 7,
   "metadata": {
    "tags": [
     "hide-input"
    ]
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "|  n  | T(n)|\n",
      "-------------\n",
      "|   1 |   1 |\n",
      "|   2 |   3 |\n",
      "|   3 |   6 |\n",
      "|   4 |  10 |\n",
      "|   5 |  15 |\n",
      "|   6 |  21 |\n",
      "|   7 |  28 |\n",
      "|   8 |  36 |\n",
      "|   9 |  45 |\n",
      "|  10 |  55 |\n"
     ]
    }
   ],
   "source": [
    "# Create a list of the first 10 integers.\n",
    "integers = range(1,11)\n",
    "\n",
    "# Print a nice heading.\n",
    "print('|  n  | T(n)|')\n",
    "print('-------------')\n",
    "\n",
    "# For each integer print the integer and the sum of all integer so far.\n",
    "tSum = 0\n",
    "for num in integers:\n",
    "    tSum = tSum + num\n",
    "    print('| {:3d} | {:3d} |'.format(num, tSum))"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Unfortunately this didn't turn out to be very insightful.\n",
    "\n",
    "Another approach we can take is to try to represent the sum differently. Taking a cue from the previous section we'll draw the sum visually:\n",
    "\n",
    "\n",
    "![Triangle Number](./images/triangle1.png \"triangle number\")\n",
    "<center>https://www.chegg.com/homework-help/use-ideas-behind-drawings-b-find-solution-gauss-s-problem-ex-chapter-1.1-problem-2a-solution-9780321987297-exc</center>\n",
    "\n",
    "\n",
    "It is because of this representation that the sum of the first $n$ integers is often referred to as a $n$'th `triangle number`. The value of our sum is represented by the 'area' of its triangular representation. Now, while it may not be easy to compute the area of such a triangle it is easy to compute the area of a rectangle and we can produce one by setting two triangles face to face:\n",
    "\n",
    "![Triangle Number Sum](./images/triangle-sum1.png \"triangle number sum\")\n",
    "<center>https://www.chegg.com/homework-help/use-ideas-behind-drawings-b-find-solution-gauss-s-problem-ex-chapter-1.1-problem-2a-solution-9780321987297-exc</center>\n",
    "\n",
    "This representation suggests a good conjecture for computing the $n$'th triangle number:\n",
    "$$T(n)=\\frac{(n)(n+1)}{2}.$$\n",
    "\n",
    "Unfortunately we once again lack the advanced proof technique we need to prove (using deductive thinking) that this is true for all integers $n$. So like before we've managed to obtain a really good conjecture through inductive thinking but are not able to confirm with certainty whether or not it's true. Like the previous example, some people may accept this visual argument as a proof."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### One Weird Trick\n",
    "\n",
    "From time to time neat computational tricks like this will go viral on social media. Unfortunately the people presenting them will typically only show a few flashy examples and leave the readers feeling completely mystified about __why__ the trick works (or worse, feeling betrayed when it fails).\n",
    "\n",
    "![One Weird Trick](./images/trick2.png \"Mathematicians hate him\")\n",
    "<center>https://brightside.me/article/nine-simple-math-tricks-youll-wish-you-had-always-known-92805/</center>\n",
    "\n",
    "Before we start lets first rephrase what the picture is saying:\n",
    "\n",
    "To compute $(97)(96)$:\n",
    "1. For each of our values, compute their difference from $100$:\n",
    "  - $3=100-97$\n",
    "  - $4=100-96$\n",
    "2. Multiply the differences to compute the first two digits of the result:\n",
    "  - $12=(3)(4)$\n",
    "3. Add the differences and subtract the result from $100$ to compute the remaining digits of the result:\n",
    "  - $93=100-(3+4)$\n",
    "4. Glue the two results together to get the final result:\n",
    "  - $(97)(96)=9312$\n",
    "\n",
    "It looks like step 3 could be simplified a bit to $93 = 97 - 4$ or $93 = 96 - 3$\n",
    "\n",
    "In general it looks like the algorithm may be something like this:\n",
    "\n",
    "To compute $(a)(b)$:\n",
    "1. For each of our values, compute their difference from $100$:\n",
    "  - $a'=100-a$\n",
    "  - $b'=100-b$\n",
    "2. Multiply the differences to compute the last two digits of the result:\n",
    "  - $D=(a')(b')$\n",
    "3. Add the differences and subtract the result from $100$ to compute the remaining digits of the result:\n",
    "  - $C=a-b'$\n",
    "4. Glue the two results together to get the final result:\n",
    "  - $(a)(b)=C\\text{ appended with }D$"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Next lets have the computer generate some more examples for us so that we can get a better sense of the problem through `inductive reasoning`. The two sliders below let us choose some inputs and present the result created by the algorithm as well as the actual result with a message saying `Success!` if the algorithm gave the correct answer and `Fail!` if it gave the incorrect answer."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 8,
   "metadata": {
    "tags": [
     "hide-input"
    ]
   },
   "outputs": [
    {
     "data": {
      "application/vnd.jupyter.widget-view+json": {
       "model_id": "0fce789d7f0d4f12894967a9bcd5bd73",
       "version_major": 2,
       "version_minor": 0
      },
      "text/plain": [
       "VBox(children=(IntSlider(value=100, description='a:', max=115, min=85), IntSlider(value=100, description='b:',…"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "a = widgets.IntSlider(description='a:', min=85, max=115, value=100)\n",
    "b = widgets.IntSlider(description='b:', min=85, max=115, value=100)\n",
    "\n",
    "def multiply(a,b):\n",
    "    aDiff = 100-a\n",
    "    bDiff = 100-b\n",
    "    \n",
    "    firstTwo = aDiff*bDiff\n",
    "    lastTwo = a - bDiff\n",
    "    \n",
    "    result = str(lastTwo).lstrip('0') + str(firstTwo).zfill(2)\n",
    "    print('Result: {}'.format(result))\n",
    "    print('Actual product: {}'.format((a*b)))\n",
    "    if (result == str(a*b)):\n",
    "        print('Success!')\n",
    "    else:\n",
    "        print('Fail!')\n",
    "\n",
    "out = widgets.interactive_output(multiply, {'a': a, 'b':b})\n",
    "widgets.VBox([a,b, out])"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Playing around with the sliders it seems that the algorithm fails in two cases:\n",
    "1. Where the first digits in the result are greater than $100$.\n",
    "    * for instance, for $(101)(99)$ it gives `100-1` instead of `9999`\n",
    "2. Where the first digits in the result are negative.\n",
    "    * For instance, for $(110)(110)$ it gives `120120` instead of `12100`\n",
    "\n",
    "Can you see a pattern in the way the numbers fail, maybe a way to fix it?\n",
    "\n",
    "It seems like both instances can be fixed by carrying values. Perhaps, instead of gluing values together like strings we're actually supposed to be multiplying the last digits by $100$ and adding the first digits! For instance, instead of saying $$9312 = 93\\text{ appended with }12$$ we would say $$9312=(93)(100)+12.$$"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Lets update the algorithm with this change:\n",
    "\n",
    "To compute $(a)(b)$:\n",
    "1. For each of our values, compute their difference from $100$:\n",
    "  - $a'=100-a$\n",
    "  - $b'=100-b$\n",
    "2. Multiply the differences to compute the first two digits of the result:\n",
    "  - $D=(a')(b')$\n",
    "3. Add the differences and subtract the result from $100$ to compute the remaining digits of the result:\n",
    "  - $C=a - b'$\n",
    "4. Combine the two results together to get the final result:\n",
    "  - $(a)(b)=(C)(100) + D$\n",
    "\n",
    "In other words: $$ab = [a-(100-b)](100) + (100-b)(100-a).$$\n",
    "\n",
    "Next let's create a new version of the sliders:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 9,
   "metadata": {
    "tags": [
     "hide-input"
    ]
   },
   "outputs": [
    {
     "data": {
      "application/vnd.jupyter.widget-view+json": {
       "model_id": "99525ba8f49e49649ed39a72690a89da",
       "version_major": 2,
       "version_minor": 0
      },
      "text/plain": [
       "VBox(children=(IntSlider(value=100, description='a:', max=115, min=85), IntSlider(value=100, description='b:',…"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "a = widgets.IntSlider(description='a:', min=85, max=115, value=100)\n",
    "b = widgets.IntSlider(description='b:', min=85, max=115, value=100)\n",
    "\n",
    "def multiply(a,b):\n",
    "    aDiff = 100-a\n",
    "    bDiff = 100-b\n",
    "    \n",
    "    firstTwo = aDiff*bDiff\n",
    "    lastTwo = 100 - (aDiff + bDiff)\n",
    " \n",
    "    result = lastTwo*100 + firstTwo\n",
    "    print('Result: {}'.format(result))\n",
    "    print('Actual product: {}'.format((a*b)))\n",
    "    if (result == a*b):\n",
    "        print('Success!')\n",
    "    else:\n",
    "        print('Fail!')\n",
    "\n",
    "out = widgets.interactive_output(multiply, {'a': a, 'b':b})\n",
    "widgets.VBox([a,b, out])"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "For the two failing examples mentioned above we now get:\n",
    "* For $(101)(99)$ we get `9999` which is correct!\n",
    "* For $(110)(110)$ we get `12100` which is correct!\n",
    "\n",
    "Now that we have a conjecture let's getting a better sense of why it works. One thing we can do is to take our equation from above:\n",
    "\n",
    "$$\n",
    "\\begin{align}\n",
    "ab &= [a-(100-b)](100) + (100-b)(100-a) \\\\\n",
    "&= (a)(100) - (100-b)(100) + (100-b)(100-a)\n",
    "\\end{align}\n",
    "$$"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "We can visualize this:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 10,
   "metadata": {
    "tags": [
     "hide-input"
    ]
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "<iframe scrolling=\"no\" title=\"cc-20-weird-trick\" src=\"https://www.geogebra.org/material/iframe/id/cb88dnrd/width/732/height/415/border/888888/sfsb/true/smb/false/stb/false/stbh/false/ai/false/asb/false/sri/false/rc/false/ld/false/sdz/false/ctl/false\" width=\"732px\" height=\"415px\" style=\"border:0px;\"> </iframe>\n"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "%%html\n",
    "<iframe scrolling=\"no\" title=\"cc-20-weird-trick\" src=\"https://www.geogebra.org/material/iframe/id/cb88dnrd/width/732/height/415/border/888888/sfsb/true/smb/false/stb/false/stbh/false/ai/false/asb/false/sri/false/rc/false/ld/false/sdz/false/ctl/false\" width=\"732px\" height=\"415px\" style=\"border:0px;\"> </iframe>"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Note: This visualization assumes that $a$ and $b$ are between $0$ and $100$ (though in our conjecture we also allow them be greater than $100$)."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "In general these sorts of techniques where one performs a computation by manipulating the digits of a value is called an 'algorism' (not to be confused with algorithm). They're not really used very much these days (except for fast mental math gimmicks).\n",
    "\n",
    "This particular algorism has a lot of generalizations for dealing with larger numbers but the reasoning behind them gets quite convoluted and in the end the most important part isn't proving that a algorism works for all numbers but that it works for all the numbers for which a mental computation is fast. In this case we can be satisfied by saying that this algorism works for numbers between $91$ and $109$ since those values are the easiest to use in practice."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Some Applications of Deductive Reasoning\n",
    "\n",
    "### Fractions\n",
    "\n",
    "Fractions can be difficult to manipulate. Perhaps we can use deductive reasoning to come up with some easier ways to manipulate them.\n",
    "\n",
    "First some observations:\n",
    "1. Any integer, like $3$, can be written in fraction form: \n",
    "\n",
    "$$ \n",
    "3=\\frac{3}{1}. \n",
    "$$\n",
    "\n",
    "2. Any integer except $0$, like $3$, can be put into a fraction to get $1$: \n",
    "\n",
    "$$ \n",
    "1=\\frac{3}{3}. \n",
    "$$\n",
    "\n",
    "3. In order to multiply two fractions, such as $\\frac{2}{3}$ and $\\frac{5}{7}$, just multiply the numerators and denominators: \n",
    "\n",
    "$$ \n",
    "\\left( \\frac{2}{3}\\right) \\left( \\frac{5}{7} \\right) = \\frac{(2)(5)}{(3)(7)} = \\frac{10}{21}. \n",
    "$$\n",
    "\n",
    "The first thing to note is that observation (3) gives us a way to factor any fraction: \n",
    "\n",
    "$$ \n",
    "\\frac{2}{3} = \\left( \\frac{2}{1}\\right) \\left( \\frac{1}{3} \\right). \n",
    "$$\n",
    "\n",
    "Reducing a fraction, such as $\\frac{10}{15}$ to $\\frac{2}{3}$, can be achieved by applying observations (2) and (3) in reverse: \n",
    "\n",
    "$$\n",
    "\\frac{10}{15}=\\frac{(2)(5)}{(3)(5)}=\\left(\\frac{2}{3}\\right)\\left(\\frac{5}{5}\\right)=\\left(\\frac{2}{3}\\right)(1)=\\frac{2}{3}\n",
    "$$\n",
    "\n",
    "The usual process of cancelling a denominator, like $(3) \\left(\\frac{2}{3}\\right)=2$ follows from these observations as well: \n",
    "\n",
    "$$ \n",
    "(3) \\left(\\frac{2}{3}\\right) = \\left(\\frac{3}{1}\\right) \\left(\\frac{2}{1}\\right)\\left(\\frac{1}{3}\\right) = \\left(\\frac{3}{3}\\right) \\left(\\frac{2}{1}\\right) = (1)(2) = 2\n",
    "$$\n",
    "\n",
    "Let's use these observations to manipulate some more complicated fractions.\n",
    "\n",
    "$$\n",
    "\\begin{align*}\n",
    "    \\frac{2}{\\frac{1}{5}}\n",
    "    & = \\left( \\frac{2}{\\frac{1}{5}}\\right) (1) \\tag{Multiply by $1$}\\\\\n",
    "    & = \\left( \\frac{2}{\\frac{1}{5}}\\right) \\left(\\frac{5}{5} \\right) \\tag{By observation 2}\\\\\n",
    "    & = \\frac{(2)(5)}{\\left( \\frac{1}{5}\\right) (5)} \\tag{By observation 3}\\\\\n",
    "    & = \\frac{(2)(5)}{1} \\tag{By cancelling}\\\\\n",
    "    & = (2)(5) \\tag{By observation 1}\\\\\n",
    "    & = 10\n",
    "\\end{align*}\n",
    "$$\n",
    "\n",
    "Another more complicated example:\n",
    "\n",
    "$$\n",
    "\\begin{align*}\n",
    "    \\frac{\\frac{2}{3}}{\\frac{7}{5}}\n",
    "    & = \\left( \\frac{\\frac{2}{3}}{\\frac{7}{5}} \\right) (1)(1) \\tag{Multiply by $1$}\\\\\n",
    "    & = \\left( \\frac{\\frac{2}{3}}{\\frac{7}{5}} \\right) \\left(\\frac{3}{3} \\right)\\left(\\frac{5}{5} \\right) \\tag{By observation 2}\\\\\n",
    "    & = \\frac{\\left( \\frac{2}{3} \\right) (3)(5)}{\\left(\\frac{7}{5} \\right) (3)(5)} \\tag{By observation 3}\\\\\n",
    "    & = \\frac{(2)(5)}{(7)(3)} \\tag{By cancelling}\\\\\n",
    "    & = \\frac{10}{21}\n",
    "\\end{align*}\n",
    "$$\n",
    "\n",
    "We can manipulate even the most complicated fractions by __cleverly multiplying by 1__ in this way."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Distributive Property\n",
    "\n",
    "The distributive property is extremely useful in simplifying expressions and performing computations. In fact, every multiplication algorithm you encounter will at some level boil down to some clever application of the distributive property. Simply put the distributive property tells us how addition and multiplication interact: \n",
    "\n",
    "$$\n",
    "(a+b)c = ac + bc.\n",
    "$$\n",
    "\n",
    "Since multiplication is commutative this statement is equivalent: \n",
    "\n",
    "$$\n",
    "a(c+d) = ac + ad.\n",
    "$$\n",
    "\n",
    "The FOIL mnemonic is just a special case of the distributive property:\n",
    "\n",
    "$$ \n",
    "(a+b)(c+d) = (a+b)c + (a+b)d = ac + bc + ad + bd. \n",
    "$$\n",
    "\n",
    "It is important to remember that the distributive property can be read two ways. In one sense it tells us how to distribute multiplication across addition but in another sense it tells us how to undo that distribution.\n",
    "\n",
    "For an example, suppose you have something like \n",
    "\n",
    "$$\n",
    "6x + 10xy.\n",
    "$$\n",
    "\n",
    "If we notice that both $6x$ and $10xy$ have $2x$ as a factor, since $6x=2x(3)$ and $10xy=2x(5y)$, then we can rewrite that as \n",
    "\n",
    "$$\n",
    "6x + 10xy = 2x(3 + 5y).\n",
    "$$\n",
    "\n",
    "This technique is an extremely useful application of deductive reasoning. *Do not underestimate it.*"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Mentally Computing Simple Percentages\n",
    "\n",
    "There are many occasions where one might be asked to compute a percentage of some value on the spot (eg. tipping at a restaurant). Fortunately there's a trick to doing it quickly.\n",
    "\n",
    "First notice that computing $10\\%$ is as easy as moving the decimal point one digit to the left (eg. $10\\%$ of $25.3$ is $2.53$). Similarly, $1\\%$ can be computed by moving the decimal point two digits to the left.\n",
    "\n",
    "From there on it's just a matter of adding, subtracting, and/or multiplying these percentages to get to the desired percentage. For instance, $18\\%$ can be computed by first computing $10\\%$, doubling the value to get $20\\%$, moving the decimal over one more time to get $2\\%$ and then subtracting the $2\\%$ value from the $20\\%$ value. It's easier than it sounds.\n",
    "\n",
    "This is an application of deductive reasoning because we reached all of the assertions here logically, not by looking at any patterns and conjecturing."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "[![Callysto.ca License](https://github.com/callysto/curriculum-notebooks/blob/master/callysto-notebook-banner-bottom.jpg?raw=true)](https://github.com/callysto/curriculum-notebooks/blob/master/LICENSE.md)"
   ]
  }
 ],
 "metadata": {
  "celltoolbar": "Edit Metadata",
  "kernelspec": {
   "display_name": "Python 3",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.7.4"
  },
  "latex_envs": {
   "LaTeX_envs_menu_present": true,
   "autoclose": false,
   "autocomplete": true,
   "bibliofile": "biblio.bib",
   "cite_by": "apalike",
   "current_citInitial": 1,
   "eqLabelWithNumbers": true,
   "eqNumInitial": 1,
   "hotkeys": {
    "equation": "Ctrl-E",
    "itemize": "Ctrl-I"
   },
   "labels_anchors": false,
   "latex_user_defs": false,
   "report_style_numbering": false,
   "user_envs_cfg": false
  },
  "nbTranslate": {
   "displayLangs": [
    "*"
   ],
   "hotkey": "alt-t",
   "langInMainMenu": true,
   "sourceLang": "en",
   "targetLang": "fr",
   "useGoogleTranslate": true
  }
 },
 "nbformat": 4,
 "nbformat_minor": 2
}
